;(function ($) {
    let IS_CONSOLE_LOG_ENABLED = true;

    // Log utility
    function console_log(obj) {
        if (IS_CONSOLE_LOG_ENABLED) {
            console.log('GEL PROXIMITY >', obj);
        }
    }

    function console_error(obj) {
        if (IS_CONSOLE_LOG_ENABLED) {
            console.error('GEL PROXIMITY >', obj);
        }
    }

    console_log('PS17');

    function gelPrxSetPickUpPointForCurrentCart(payload) {
        console_log('gelPrxSetPickUpPointForCurrentCart');
        $.ajax({
            url: gelprx_conf.ajax_url,
            type: 'POST',
            dataType: 'json',
            cache: false,
            data: {
                'token': gelprx_conf.ajax_token,
                'action': 'gelproximity_set_pickup_point',
                'status': 'ok',
                'payload': payload,
            }
        }).done(function (response) {
            console_log(response);
            if ($('div.gelproximity-app__selection-details').length) {
                $('div.gelproximity-app__selection-details').html(response.data.html);
            }

            // Find and manage carrier's input radio
            let $radio = $('input[value="' + gelprx_conf.id_carrier + '"]');
            console_log($radio);
            if ($radio.length) {
                $radio.trigger('change');
            } else {
                location.reload();
            }
        }).fail(function (response, err) {
            console_error(response);
            console_error(err);
            if ($('div.gelproximity-app__selection-details').length) {
                $('div.gelproximity-app__selection-details-error').removeClass('gelproximity-app__hidden');
            }
        });
    }

    function disableCheckoutPaymentStep() {
        $('div.payment-options ').addClass('gelproximity-app__hidden');
        $('#conditions-to-approve').addClass('gelproximity-app__hidden');
        $('#payment-confirmation').addClass('gelproximity-app__hidden');
    }

    function enableCheckoutPaymentStep() {
        $('div.payment-options ').removeClass('gelproximity-app__hidden');
        $('#conditions-to-approve').removeClass('gelproximity-app__hidden');
        $('#payment-confirmation').removeClass('gelproximity-app__hidden');
    }

    function init() {
        if (typeof gelprx_conf === 'undefined') {
            console_error('CONFIGURATION NOT FOUND');
        } else {
            // Check for cart id reference
            if (typeof gelprx_conf.reference === 'undefined' || gelprx_conf.reference === '') {
                console_error('CART REFERENCE NOT FOUND');
                location.reload();
            }
            // If is showed the alert about no pick up selected remove every payment option and block the checkout process
            if ($('#gelproximity-app-no-pick-point-selected').length) {
                disableCheckoutPaymentStep();
            }

            if ($('#gelproximity-app__selection-button-sdk-wrapper').length) {
                if (typeof gelprx_conf !== 'undefined') {
                    const options = {
                        apiKey: gelprx_conf.apiKey,
                        merchantCode: gelprx_conf.merchantCode,
                        reference: gelprx_conf.reference,
                        redirectMode: gelprx_conf.redirectMode,
                        locale: gelprx_conf.locale,
                        urlEndUser: gelprx_conf.urlEndUser,
                        urlRedirectOk: gelprx_conf.urlRedirectOk,
                        urlRedirectCancel: gelprx_conf.urlRedirectCancel,
                    };
                    const gelSDK = new GelSDK(options);

                    const gelUIModalOptions = {
                        callbackOk: (data) => {
                            // Funzione nel caso venga selezionato un punto di ritiro
                            console_log('modal pick-up point selected');
                            console_log(data);
                            gelPrxSetPickUpPointForCurrentCart(data);
                        },
                        callbackKo: () => {
                            // Funzione nel caso venga chiusa la modale della mappa
                            console_log('modal closed');
                        }
                    };

                    function renderButtonModal() {
                        gelSDK.createUIModal(gelUIModalOptions);
                    }

                    $('#gelproximity-app-pick-point-select-button').unbind('click').on('click', function () {
                        console_log('pick-up button clicked');
                        if (typeof gelprx_conf.reference === 'undefined' || gelprx_conf.reference === '') {
                            console_error('CART REFERENCE NOT FOUND');
                            location.reload();
                        }
                        renderButtonModal();
                    });

                    // Find and manage carrier's input radio
                    let $radio = $('input[value="' + gelprx_conf.id_carrier + '"]');
                    console_log($radio);
                    if ($radio.length) {
                        if ($radio.is(':checked') || $('ul#shipping_method input.shipping_method').length === 1) {
                            $('#gelproximity-app').show();
                        } else {
                            $('#gelproximity-app').hide();
                        }
                        $radio.on('change', function () {
                            if ($radio.is(':checked')) {
                                $('#gelproximity-app').show();
                            } else {
                                $('#gelproximity-app').hide();
                            }
                        });
                    }
                }
            }
        }
    }

    // $(document).ready(function ($) {});

    // $(window).load(function () {});

    $(document).ajaxSuccess(function (event, xhr, settings) {
        if (typeof settings.data !== "undefined") {
            // console_log(settings.data);
            if (settings.data.indexOf('payment_method') !== -1) {
                init();
            }
        }
    });
})(jQuery);