<?php

class GelProximityCartPrice {
	public static function getIDbyPsIdCart( $id_cart ) {
		global $wpdb;

		$sql = 'SELECT `id_gelprx_cart_price`
        FROM `' . $wpdb->prefix . 'gelprx_cart_price`
        WHERE `id_cart` = "' . sanitize_key( trim( $id_cart ) ) . '"';

		return $wpdb->get_var( $sql );
	}

	public static function getCostByPsIdCart( $id_cart ) {
		global $wpdb;

		$sql = 'SELECT `cost`
        FROM `' . $wpdb->prefix . 'gelprx_cart_price`
        WHERE `id_cart` = "' . sanitize_key( trim( $id_cart ) ) . '"';

		// TODO: cache on $key
		$key = GelProximityUtility::buildOrderReference( $id_cart );

		$result = $wpdb->get_var( $sql );

		if ( is_null( $result ) ) {
			return false;
		}

		return $result;
	}

	public static function getPayloadByPsIdCart( $id_cart ) {
		global $wpdb;

		$sql = 'SELECT `response_payload`
        FROM `' . $wpdb->prefix . 'gelprx_cart_price`
        WHERE `id_cart` = "' . sanitize_key( trim( $id_cart ) ) . '"';

		// TODO: cache on $key

		$result = $wpdb->get_var( $sql );

		if ( is_null( $result ) ) {
			return false;
		}

		return $result;
	}

	public static function getPayloadByPsIdOrder( $id_order ) {
		if ( ! empty( $id_order ) ) {
			$order = wc_get_order( $id_order );
			if ( $order ) {
				$id_cart = get_post_meta( $id_order, '_gelproximity_order_cart_id', true ); // $order->get_cart_hash();
				if ( $id_cart ) {
					return self::getPayloadByPsIdCart( $id_cart );
				}
			}
		}

		return false;
	}

	public static function storeOrUpdate( $id_cart, $payload ) {
		global $wpdb;

		if ( empty( $id_cart ) || empty( $payload ) ) {
			return false;
		}
		$id_gelprx_cart_price = self::getIDbyPsIdCart( $id_cart );
		if ( empty( $id_gelprx_cart_price ) ) {
			$data = array(
				'id_cart'          => $id_cart,
				'response_payload' => GelProximityUtility::doSerialize( $payload ),
				'cost'             => ( $payload['cost'] / GelProximityConfiguration::GELPRX_DEFAULT_VAT ),
				'currency'         => $payload['currencyCost'],
				'date_add'         => date( 'Y-m-d H:i:s' ),
			);

			return $wpdb->insert( $wpdb->prefix . 'gelprx_cart_price', $data );
		} else {
			$data = array(
				'response_payload' => GelProximityUtility::doSerialize( $payload ),
				'cost'             => ( $payload['cost'] / GelProximityConfiguration::GELPRX_DEFAULT_VAT ),
				'currency'         => $payload['currencyCost'],
				'date_upd'         => date( 'Y-m-d H:i:s' ),
			);

			return $wpdb->update( $wpdb->prefix . 'gelprx_cart_price', $data,
				array( 'id_gelprx_cart_price' => $id_gelprx_cart_price ) );
		}
	}
}
