<?php

class GelProximityOrderHistory {
	public static function getIDbyPsIdCart( $id_cart ) {
		global $wpdb;

		$sql = 'SELECT `id_gelprx_order_history`
        FROM `' . $wpdb->prefix . 'gelprx_order_history`
        WHERE `id_cart` = "' . sanitize_key( trim( $id_cart ) ) . '"';

		return $wpdb->get_var( $sql );
	}

	public static function getAllByPsIdCart( $id_cart ) {
		global $wpdb;

		$sql = 'SELECT *
        FROM `' . $wpdb->prefix . 'gelprx_order_history`
        WHERE `id_cart` = "' . sanitize_key( trim( $id_cart ) ) . '"';

		return $wpdb->get_row( $sql, 'ARRAY_A' );
	}

	public static function getIDbyPsIdOrder( $id_order ) {
		global $wpdb;

		$sql = 'SELECT `id_gelprx_order_history`
        FROM `' . $wpdb->prefix . 'gelprx_order_history`
        WHERE `id_order` = "' . sanitize_key( trim( $id_order ) ) . '"';

		return $wpdb->get_var( $sql );
	}

	public static function storeOrUpdate( $id_cart, $id_order, $response ) {
		if ( empty( $id_cart ) || empty( $id_order ) ) {
			return false;
		}

		global $wpdb;

		$id_gelprx_order_history = self::getIDbyPsIdCart( $id_cart );
		if ( empty( $id_gelprx_order_history ) ) {
			$data = array(
				'id_cart'  => $id_cart,
				'id_order' => $id_order,
				'date_add' => date( 'Y-m-d H:i:s' ),
			);

			if ( is_array( $response ) ) {
				$data['response_success'] = (bool) $response['success'];
				$data['response_message'] = $response['message'];
			}

			return $wpdb->insert( $wpdb->prefix . 'gelprx_order_history', $data );
		} else {
			if ( is_array( $response ) ) {
				$data                     = array();
				$data['response_success'] = (bool) $response['success'];
				$data['response_message'] = $response['message'];
				$data['date_upd']         = date( 'Y-m-d H:i:s' );

				return $wpdb->update( $wpdb->prefix . 'gelprx_order_history', $data,
					array( 'id_gelprx_order_history' => $id_gelprx_order_history ) );
			}
		}
	}

	public static function getOrderCountInCurrentYear( $is_add_one = false ) {
		$order_status_paid_arr = get_option( GelProximityConfiguration::GELPRX_CONFIG_OPTION_SETTINGS_KEY )['confirm_order_statuses'];

		// array(3) { [0]=> string(13) "wc-processing" [1]=> string(10) "wc-on-hold" [2]=> string(12) "wc-completed" }

		// Alternative
		/*
		$initial_date = date('Y').'01-01';
		$final_date = date('Y-m-d');
		$orders = wc_get_orders(array(
				'limit'=>-1,
				'type'=> 'shop_order',
				'status'=> $order_status_paid_arr,
				'date_created'=> $initial_date .'...'. $final_date
			)
		);
		*/

		if ( ! empty( $order_status_paid_arr ) ) {
			global $wpdb;

			$post_status = implode( "','", $order_status_paid_arr );

			$result = $wpdb->get_var( "SELECT COUNT(DISTINCT(`ID`)) FROM $wpdb->posts 
            WHERE post_type = 'shop_order'
            AND post_status IN ('{$post_status}')
            AND YEAR(`post_date`) = YEAR(CURDATE())" );

			if ( $is_add_one ) {
				return (int) $result + 1;
			} else {
				return (int) $result;
			}
		}

		return 0;
	}
}
